;
; POCKET SINGER for SHARP POCKET COMPUTER PC-G850/S/V/VS
; o
;

;
; ̂
;
; 
; HL:̂̐擪
;
; o
; AF,BC,DE,HL,IX:j
;
sing_loop:
	; ?
	ld A, (HL)
	inc HL
	cp #0xff
	jr Z, sing_skip

	; 𓾂
	push HL
	ld L, A
	ld H, #0
	add HL, HL
	add HL, HL
	ld IX, #voice_none
	ex DE, HL
	add IX, DE
	pop HL
sing_skip:

	; L[IԂ𓾂
	ld E, (HL)
	inc HL
	ld D, (HL)
	inc HL

	; o͂
	push BC
	push HL
	call speak
	pop HL
	pop BC

	; L[ItԂ𓾂
	ld E, (HL)
	inc HL
	ld D, (HL)
	inc HL

	; ő҂
	push HL
	push IX
	ld IX, #voice_none
	ld A, D
	or E
	call NZ, speak
	pop IX
	pop HL

sing::
	; BREAKL[ꂽ?
	in A, (#0x1f)
	rlca
	jr C, sing_last

	; g𓾂
	ld C, (HL)
	inc HL
	ld B, #0

	; I肩?
	inc C
	dec C
	jr NZ, sing_loop

sing_last:
	; o͂OFFɂ
	xor A
	out (#0x18), A
	ret

;
; o͂
;
; 
; BC:g
; DE:
; IX:
;
; o
; IX:̉f[^
; AF,BC,DE,HL:j
;
speak::
	; ҂ԒpWvݒ肷
	ld HL, #output1bit_skip
	or A
	sbc HL, BC
	ld (#output1bit_jp + 1), HL

	; ̉AhX𓾂
	ld L, 2(IX)
	ld H, 3(IX)
	push HL

	; ̔g`AhXۑ
	ld C, (HL)
	inc HL
	ld B, (HL)
	ld (#next_wave), BC

	; ŏ̔g`AhX𓾂
	ld L, 0(IX)
	ld H, 1(IX)

	; g`f[^𓾂
	ld C, (HL)
	inc HL
	ld B, (HL)
	inc HL

	pop IX
	jp speak_loop

speak_restart:
	; ̔g`AhX𓾂
	ld HL, (#next_wave)

	; g`f[^𓾂
	ld C, (HL)
	inc HL
	ld B, (HL)
	inc HL

speak_loop:
	; 1oCgo͂
	ld A, (HL)
	inc HL
	call output1bit
	jp C, speak_restart
	nop
	nop
	nop
	nop
	nop
	nop
	call output1bit
	jp C, speak_restart
	nop
	nop
	nop
	nop
	nop
	nop
	call output1bit
	jp C, speak_restart
	nop
	nop
	nop
	nop
	nop
	nop
	call output1bit
	jp C, speak_restart
	nop
	nop
	nop
	nop
	nop
	nop
	call output1bit
	jp C, speak_restart
	nop
	nop
	nop
	nop
	nop
	nop
	call output1bit
	jp C, speak_restart
	nop
	nop
	nop
	nop
	nop
	nop
	call output1bit
	jp C, speak_restart
	nop
	nop
	nop
	nop
	nop
	nop
	call output1bit
	jp C, speak_restart
	jp speak_loop

next_wave:
	.dw 0x0000

;
; 1bito͂ (speak̉)
;
; 
; A:ŏbit1̂ƂON, 0̂ƂOFF
; BC:o͈ʒuJE^
; DE:o͎ԃJE^
;
; o
; A:ɃVtg
; Cy:o͈ʒuJE^0, NC:o͈ʒuJE^0łȂ
; BC:1Z
; DE:1Z
;
output1bit:
	; 1bitVtg
	rlca
	push AF

	; 1bito͂
	and #0x80
	out (#0x18), A

	; ҂
output1bit_jp:
	jp output1bit_skip
	call delay21	; _~[
	call delay20	; _~[
	call delay18	; _~[
	call delay16	; _~[
	call delay15	; _~[
	call delay15	; _~[
	call delay12	; _~[
	call delay12	; _~[
	call delay11	; _~[
	call delay10	; _~[
	call delay9	; _~[
	call delay8	; _~[
	call delay7	; _~[
	call delay7	; _~[
	call delay6	; _~[
	call delay5	; _~[
	call delay4	; _~[
	call delay4	; _~[
	call delay3	; _~[
	call delay3	; _~[
	call delay2	; _~[
	call delay2	; _~[
	call delay1	; _~[
	call delay1	; _~[
	call delay0	; _~[
	call delay0	; _~[
	nop	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	call delay0	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	nop	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	nop	; _~[
	ld A, (HL)	; _~[
	ld A, (HL)	; _~[
	call delay15	; _~[
output1bit_skip:

	; o͈ʒuJE^炷
	dec BC
	ld A, B
	or C
	jp Z, output1bit_bc_z

	; o͎ԃJE^炷
	pop AF
	ex AF, AF'
	dec DE
	ld A, D
	or E
	jp Z, output1bit_de_z
	ex AF, AF'
	or A
	ret

output1bit_bc_z:
	; o͈ʒuJE^0
	pop AF
	scf
	ret

output1bit_de_z:
	; o͎ԃJE^0
	pop AF
	ret

;
; ҂
;
; 
; Ȃ
;
; o
; Ȃ
;
delay23:
	nop
delay22:
	nop
delay21:
	nop
delay20:
	nop
delay19:
	nop
delay18:
	nop
delay17:
	nop
delay16:
	nop
delay15:
	nop
delay14:
	nop
delay13:
	nop
delay12:
	nop
delay11:
	nop
delay10:
	nop
delay9:
	nop
delay8:
	nop
delay7:
	nop
delay6:
	nop
delay5:
	nop
delay4:
	nop
delay3:
	nop
delay2:
	nop
delay1:
	nop
delay0:
	ret

voice_none::	.dw wave_none, voice_none	; 

voice_a::	.dw wave_a, voice_a	; [(A)
voice_i::	.dw wave_i, voice_i	; [(C)
voice_u::	.dw wave_u, voice_u	; [(E)
voice_e::	.dw wave_e, voice_e	; [(G)
voice_o::	.dw wave_o, voice_o	; [(I)

voice_aa::	.dw wave_aa, voice_a	; A
voice_ii::	.dw wave_ii, voice_i	; C
voice_uu::	.dw wave_uu, voice_u	; E
voice_ee::	.dw wave_ee, voice_e	; G
voice_oo::	.dw wave_oo, voice_o	; I

voice_ka::	.dw wave_ka, voice_a	; J
voice_ki::	.dw wave_ki, voice_i	; L
voice_ku::	.dw wave_ku, voice_u	; N
voice_ke::	.dw wave_ke, voice_e	; P
voice_ko::	.dw wave_ko, voice_o	; R

voice_kya::	.dw wave_ki, voice_a	; L
voice_kyu::	.dw wave_ki, voice_u	; L
voice_kye::	.dw wave_ki, voice_e	; LF
voice_kyo::	.dw wave_ki, voice_o	; L

voice_qa::	.dw wave_ku, voice_a	; N@
voice_qi::	.dw wave_ku, voice_i	; NB
voice_qe::	.dw wave_ka, voice_e	; NF
voice_qo::	.dw wave_ka, voice_o	; NH

voice_ga::	.dw wave_ga, voice_a	; K
voice_gi::	.dw wave_gi, voice_i	; M
voice_gu::	.dw wave_gu, voice_u	; O
voice_ge::	.dw wave_ge, voice_e	; Q
voice_go::	.dw wave_go, voice_o	; S

voice_gya::	.dw wave_gi, voice_a	; M
voice_gyu::	.dw wave_gi, voice_u	; M
voice_gye::	.dw wave_gi, voice_e	; MF
voice_gyo::	.dw wave_gi, voice_o	; M

voice_sa::	.dw wave_sa, voice_a	; T
voice_shi::	.dw wave_shi, voice_i	; V
voice_su::	.dw wave_su, voice_u	; X
voice_se::	.dw wave_se, voice_e	; Z
voice_so::	.dw wave_so, voice_o	; \

voice_sha::	.dw wave_shi, voice_a	; V
voice_swi::	.dw wave_swi, wave_i	; XB
voice_shu::	.dw wave_shi, voice_u	; V
voice_she::	.dw wave_shi, voice_e	; VF
voice_sho::	.dw wave_shi, voice_o	; V

voice_za::	.dw wave_za, voice_a	; U
voice_zi::				; W
voice_di::	.dw wave_zi, voice_i	; a
voice_zu::				; Y
voice_du::	.dw wave_zu, voice_u	; d
voice_ze::	.dw wave_ze, voice_e	; [
voice_zo::	.dw wave_zo, voice_o	; ]

voice_ja::	.dw wave_zi, voice_a	; W
voice_zwi:	.dw wave_za, voice_i	; YB
voice_ju::	.dw wave_zi, voice_u	; W
voice_je::	.dw wave_zi, voice_e	; WF
voice_jo::	.dw wave_zi, voice_o	; W

voice_ta::	.dw wave_ta, voice_a	; ^
voice_chi::	.dw wave_chi, voice_i	; `
voice_tsu::	.dw wave_tsu, voice_u	; c
voice_te::	.dw wave_te, voice_e	; e
voice_to::	.dw wave_to, voice_o	; g

voice_tha::	.dw wave_te, voice_a	; e
voice_ti::	.dw wave_ta, voice_i	; eB
voice_thu::	.dw wave_te, voice_u	; e
voice_the::	.dw wave_te, voice_e	; eF
voice_tho::	.dw wave_te, voice_o	; e

voice_tu::	.dw wave_ta, voice_u	; gD

voice_txa::	.dw wave_txa, voice_a	; c@
voice_txi::	.dw wave_txa, voice_i	; cB
voice_txe::	.dw wave_txa, voice_e	; cF
voice_txo::	.dw wave_txa, voice_o	; cH

voice_da::	.dw wave_da, voice_a	; _
voice_de::	.dw wave_de, voice_e	; f
voice_do::	.dw wave_do, voice_o	; h

voice_dha::	.dw wave_de, voice_a	; f
voice_dhi::	.dw wave_da, voice_i	; fB
voice_dhu::	.dw wave_de, voice_u	; f
voice_dhe::	.dw wave_de, voice_e	; fF
voice_dho::	.dw wave_de, voice_o	; f

voice_dwu::	.dw wave_da, voice_u	; hD

voice_cha::	.dw wave_chi, voice_a	; `
voice_chu::	.dw wave_chi, voice_u	; `
voice_che::	.dw wave_chi, voice_e	; `F
voice_cho::	.dw wave_chi, voice_o	; `

voice_na::	.dw wave_na, voice_a	; i
voice_ni::	.dw wave_ni, voice_i	; j
voice_nu::	.dw wave_nu, voice_u	; k
voice_ne::	.dw wave_ne, voice_e	; l
voice_no::	.dw wave_no, voice_o	; m

voice_nya::	.dw wave_nya, voice_a	; j
voice_nyu::	.dw wave_nyu, voice_u	; j
voice_nye::	.dw wave_nye, voice_e	; jF
voice_nyo::	.dw wave_nyo, voice_o	; j

voice_ha::	.dw wave_ha, voice_a	; n
voice_hi::	.dw wave_hi, voice_i	; q
voice_fu::	.dw wave_fu, voice_u	; t
voice_he::	.dw wave_he, voice_e	; w
voice_ho::	.dw wave_ho, voice_o	; z

voice_hya::	.dw wave_hi, voice_a	; q
voice_hu::	.dw wave_hi, voice_u	; q
voice_hye::	.dw wave_hi, voice_e	; qF
voice_hyo::	.dw wave_hi, voice_o	; q

voice_fa::	.dw wave_fu, voice_a	; t@
voice_fi::	.dw wave_fu, voice_i	; tB
voice_fe::	.dw wave_fu, voice_e	; tF
voice_fo::	.dw wave_fu, voice_o	; tH

voice_fya::	.dw wave_fya, voice_a	; t
voice_fye::	.dw wave_fya, voice_a	; tF
voice_fyo::	.dw wave_fya, voice_a	; t

voice_ba::	.dw wave_ba, voice_a	; o
voice_bi::	.dw wave_bi, voice_i	; r
voice_bu::	.dw wave_bu, voice_u	; u
voice_be::	.dw wave_be, voice_e	; x
voice_bo::	.dw wave_bo, voice_o	; {

voice_bya::	.dw wave_bi, voice_a	; r
voice_byu::	.dw wave_bi, voice_u	; r
voice_bye::	.dw wave_bi, voice_e	; rF
voice_byo::	.dw wave_bi, voice_o	; r

voice_pa::	.dw wave_pa, voice_a	; p
voice_pi::	.dw wave_pi, voice_i	; s
voice_pu::	.dw wave_pu, voice_u	; v
voice_pe::	.dw wave_pe, voice_e	; y
voice_po::	.dw wave_po, voice_o	; |

voice_pya::	.dw wave_pi, voice_a	; s
voice_pyu::	.dw wave_pi, voice_u	; s
voice_pye::	.dw wave_pi, voice_e	; sF
voice_pyo::	.dw wave_pi, voice_o	; s

voice_ma::	.dw wave_ma, voice_a	; }
voice_mi::	.dw wave_mi, voice_i	; ~
voice_mu::	.dw wave_mu, voice_u	; 
voice_me::	.dw wave_me, voice_e	; 
voice_mo::	.dw wave_mo, voice_o	; 

voice_mya::	.dw wave_mya, voice_a	; ~
voice_myu::	.dw wave_myu, voice_u	; ~
voice_mye::	.dw wave_mye, voice_e	; ~F
voice_myo::	.dw wave_myo, voice_o	; ~

voice_ya::	.dw wave_ya, voice_a	; 
voice_yu::	.dw wave_yu, voice_u	; 
voice_ye::	.dw wave_yo, voice_e	; CF
voice_yo::	.dw wave_yo, voice_o	; 

voice_ra::	.dw wave_ra, voice_a	; 
voice_ri::	.dw wave_ri, voice_i	; 
voice_ru::	.dw wave_ru, voice_u	; 
voice_re::	.dw wave_re, voice_e	; 
voice_ro::	.dw wave_ro, voice_o	; 

voice_rya::	.dw wave_rya, voice_a	; 
voice_ryu::	.dw wave_rya, voice_u	; 
voice_rye::	.dw wave_rya, voice_e	; F
voice_ryo::	.dw wave_rya, voice_o	; 

voice_wa::	.dw wave_wa, voice_a	; 
voice_wi::	.dw wave_wa, voice_i	; EB
voice_wu::	.dw wave_wa, voice_u
voice_we::	.dw wave_wa, voice_e	; EF
voice_wo::	.dw wave_wa, voice_o	; EH

voice_va::	.dw wave_va, voice_a	; @
voice_vi::	.dw wave_va, voice_i	; B
voice_vu::	.dw wave_vu, voice_u	; 
voice_ve::	.dw wave_va, voice_e	; F
voice_vo::	.dw wave_va, voice_o	; H

voice_n::	.dw wave_n, voice_n	; 

wave_none::
	.dw 64 - 1
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00

;
; Copyright 2013 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
