;
; POCKET SINGER for SHARP POCKET COMPUTER PC-G850/S/V/VS
; eLXgEoCiϊ
;

;
; eLXg̉̂oCiɕϊ
;
; 
; Ȃ
;
; o
; Cy:, NC:G[
; A:G[R[h
; DE:G[̔
; HL:G[̔s
; F,BC,DE,HL,IX,IY:j
;
compile_song::
	; ftHg̃p[^ݒ肷
	ld HL, #tempo
	ld (HL), #120
	inc HL
	ld (HL), #4
	inc HL
	ld (HL), #7
	inc HL
	ld (HL), #12
	inc HL
	ld (HL), #0

	; eLXg̐擪𓾂
	ld IX, (#0x7ffe)
	ld BC, #25
compile_song_loop1:
	add IX, BC
	ld C, 17(IX)
	ld B, 18(IX)
	ld A, 0(IX)
	inc A
	jr NZ, compile_song_loop1
	push IX
	pop HL
	inc HL

	; ݈ʒu
	ld IX, #song
	ld IY, #song

compile_song_loop2:
	; sԍ𓾂
	ld B, (HL)
	inc HL
	ld C, (HL)
	inc HL
	ld (#compile_song_line), BC
	inc HL
	ld (#compile_song_start), HL

	; sԍ0xffffȂI
	ld A, B
	and C
	inc A
	jr Z, compile_song_last

	; 1sRpC
	call read_command
	jr C, compile_song_loop2

compile_song_ng:
	; 𓾂
	ld DE, (#compile_song_start)
	sbc HL, DE
	ex DE, HL

	; s𓾂
	ld HL, (#compile_song_line)
	or A
	ret

compile_song_last:
	; Ȃ?
	push HL
	push IX
	pop HL
	push IY
	pop BC
	or A
	sbc HL, DE
	pop HL
	ld A, #2 ; G[ : Ȃ
	jr Z, compile_song_ng

	; 
	scf
	ret

; RpC̍sԍ
compile_song_line:
	.dw 0x0000

; RpC̍s̐擪
compile_song_start:
	.dw 0x0000

;
; R}h1sǂݍ
;
; 
; HL:eLXg̓ǍAhX
; IX:̏AhX
; IY:̏AhX
;
; o
; A:G[R[h
; Cy:, NC:G[
; HL:eLXg̓ǍAhX
; IX:̏AhX
; IY:̏AhX
; F,BC,DE:j
;
read_command::
	; R}h𓾂
	ld A, (HL)
	inc HL

	; 󔒂?
	cp #" "
	jr Z, read_command

	; Rg?
	cp #";"
	jr Z, read_command_comment

	; s?
	cp #0x0d
	scf
	ret Z

	; R}h?
	dec HL
	rlca
	jr C, read_command_voice

read_command_sound:
	; ǂݍ
	call read_sound
	ret NC
	jr read_command

read_command_voice:
	; ǂݍ
	call read_voice
	ret NC
	jr read_command

read_command_comment:
	; Rgǂݔ΂
	ld A, (HL)
	inc HL
	cp #0x0d
	jr NZ, read_command_comment
	scf
	ret

;
; 1R}hǂݍ (read_command̉)
;
; 
; A:G[R[h
; HL:eLXg̓ǍAhX
; IX:̏AhX
;
; o
; HL:eLXg̓ǍAhX
; IX:̏AhX
; Cy:, NC:G[
; AF,BC,DE:j
;

; Qݒ肷
read_sound_set_q:
	call get_number
	cp #9
	jr C, read_sound_set
	ld A, #8 ; G[ : p[^͈͊O
	ret

; ڒ
read_sound_trans:
	ld DE, #trans

	ld A, (HL)
	cp #"-"
	jr NZ, read_sound_set_param
	inc HL

	call get_number
	neg
	jr read_sound_set

; lݒ肷
read_sound_set_param:
	call get_number
	jr read_sound_set

; IN^[uグ/
read_sound_up_down:
	ld A, (DE)
	add C
	jr read_sound_set

; IN^[uݒ肷
read_sound_octave:
	call get_number
	sub #2
	ld C, A
	add A
	add A
	add A
	add C
	add C
	add C
	add C
read_sound_set:
	ld (DE), A
	scf
	ret

; 1R}hǂݍ
read_sound:
	; R}h𓾂
	ld A, (HL)
read_sound_start:
	inc HL

	; e|ݒ肩?
	ld DE, #tempo
	cp #"T"
	jr Z, read_sound_set_param
	cp #"t"
	jr Z, read_sound_set_param

	; ݒ肩?
	ld DE, #length
	cp #"L"
	jr Z, read_sound_set_param
	cp #"l"
	jr Z, read_sound_set_param

	; Qݒ肩?
	ld DE, #q
	cp #"Q"
	jr Z, read_sound_set_q
	cp #"q"
	jr Z, read_sound_set_q

	; ڒ?
	cp #"_"
	jr Z, read_sound_trans

	; 1IN^[u邩?
	ld DE, #octave
	ld C, #-12
	cp #"<"
	jr Z, read_sound_up_down

	; 1IN^[uグ邩?
	ld BC, #12
	cp #">"
	jr Z, read_sound_up_down

	; IN^[uݒ肩?
	cp #"O"
	jr Z, read_sound_octave
	cp #"o"
	jr Z, read_sound_octave

	; x?
	ld C, #36
	cp #"R"
	jr Z, read_sound_rest
	cp #"r"
	jr Z, read_sound_rest
	cp #"P"
	jr Z, read_sound_rest
	cp #"p"
	jr Z, read_sound_rest

	; h?
	push AF
	ld A, (#trans)
	ex DE, HL
	add (HL)
	ex DE, HL
	ld C, A
	pop AF
	cp #"C"
	jr Z, read_sound_sound
	cp #"c"
	jr Z, read_sound_sound

	; ?
	inc C
	inc C
	cp #"D"
	jr Z, read_sound_sound
	cp #"d"
	jr Z, read_sound_sound

	; ~?
	inc C
	inc C
	cp #"E"
	jr Z, read_sound_sound
	cp #"e"
	jr Z, read_sound_sound

	; t@?
	inc C
	cp #"F"
	jr Z, read_sound_sound
	cp #"f"
	jr Z, read_sound_sound

	; \?
	inc C
	inc C
	cp #"G"
	jr Z, read_sound_sound
	cp #"g"
	jr Z, read_sound_sound

	; ?
	inc C
	inc C
	cp #"A"
	jr Z, read_sound_sound
	cp #"a"
	jr Z, read_sound_sound

	; V?
	inc C
	inc C
	cp #"B"
	jr Z, read_sound_sound
	cp #"b"
	jr Z, read_sound_sound

; sȃR}h
read_sound_error:
	dec HL
	ld A, #3 ; G[ : sȉR}h
	or A
	ret

; ͈͊O
read_sound_error_range:
	dec HL
	ld A, #5 ; Ⴗ
	ret M
	ld A, #6 ; 
	ret

; 
read_sound_sound:
	; V[v(+)?
	ld A, (HL)
	cp #"+"
	jr NZ, read_sound_skip1
	inc HL

	; グ
	inc C
read_sound_skip1:

	; V[v(#)?
	cp #"#"
	jr NZ, read_sound_skip2
	inc HL

	; グ
	inc C
read_sound_skip2:

	; tbg?
	cp #"-"
	jr NZ, read_sound_skip3
	inc HL

	; 
	dec C
read_sound_skip3:

	; ͈̔͂`FbN
	ld A, C
	cp #36
	jr NC, read_sound_error_range

read_sound_rest:
	; g
	push HL
	ld HL, #wavelength_table
	add HL, BC
	ld A, (HL)
	ld 0(IX), A

	; Ԃ𓾂
	ld HL, #base_time_table
	add HL, BC
	add HL, BC
	add HL, BC
	ld C, (HL)
	inc HL
	ld B, (HL)
	inc HL
	ld E, (HL)
	ld D, #0

	; e|Ŋ
	ld A, (#tempo)
	call div24_8
	pop HL

	; Ŋ
	call get_number
	jr C, read_sound_skip4
	ld A, (#length)
read_sound_skip4:
	push HL
	call div24_8
	pop HL

	; Ԃ͈͓?
	or A
	inc E
	dec E
	ld A, #7 ; G[ : 
	ret NZ

	; t_?
	ld A, (HL)
	cp #"."
	jr NZ, read_sound_skip5
	inc HL

	; Ԃ1.5{ɂ
	push HL
	ld L, C
	ld H, B
	call div_bc_2
	add HL, BC
	ld C, L
	ld B, H
	pop HL

	; ͈͓?
	ld A, #7 ; G[ : 
	ccf
	ret NC
read_sound_skip5:

	; X[/^C?
	ld DE, #0
	ld A, (HL)
	inc HL
	cp #"^"
	jr Z, read_sound_skip6
	cp #"&"
	jr Z, read_sound_skip6
	dec HL

	; Q𓾂
	ld A, (#q)
	neg
	add #8
	jr Z, read_sound_skip6

	; L[I/It̎Ԃς
	push HL
	ld DE, #0
	ld L, C
	ld H, B
	call div_bc_8

read_sound_slur_loop:
	ex DE, HL
	add HL, BC
	ex DE, HL
	or A
	sbc HL, BC
	dec A
	jr NZ, read_sound_slur_loop

	ld C, L
	ld B, H
	pop HL
read_sound_skip6:

	; Ԃ
	ld 2(IX), C
	ld 3(IX), B
	ld 4(IX), E
	ld 5(IX), D

	; ̏݃AhXֈڂ
	ld BC, #6
	add IX, BC

	; [Ü?
	push HL
	or A
	push IX
	pop HL
	ld DE, #6
	add HL, DE
	ld DE, (#0x7ffe)
	sbc HL, DE
	pop HL
	ld A, #0 ; G[ : Ȃ
	ret NC

	; I[
	ld 0(IX), #0

	; 
	scf
	ret

; e|
tempo:
	.db #0

; ȗ̒
length:
	.db #0

; oԂ̊
q:
	.db #0

; IN^[u
octave:
	.db #0

; ڒ
trans:
	.db #0

; g\
wavelength_table:
	.db 108	; 2C 
	.db 105	; 2C#
	.db 102	; 2D 
	.db 99	; 2D#
	.db 96	; 2E 
	.db 93	; 2F 
	.db 90	; 2F#
	.db 87	; 2G 
	.db 84	; 2G#
	.db 81	; 2A 
	.db 78	; 2A#
	.db 75	; 2B 
	.db 72	; 3C 
	.db 69	; 3C#
	.db 66	; 3D 
	.db 63	; 3D#
	.db 60	; 3E 
	.db 57	; 3F 
	.db 54	; 3F#
	.db 51	; 3G 
	.db 48	; 3G#
	.db 45	; 3A 
	.db 42	; 3A#
	.db 39	; 3B 
	.db 36	; 4C 
	.db 33	; 4C#
	.db 30	; 4D 
	.db 26	; 4D#
	.db 23	; 4E 
	.db 20	; 4F 
	.db 17	; 4F#
	.db 14	; 4G 
	.db 11	; 4G#
	.db 8	; 4A 
	.db 6	; 4A#
	.db 3	; 4B 
	.db 0	; R

; (e|1̑S = 4)\
base_time_table:
	.db 0x00, 0xa6, 0x0e	; 2C  960000
	.db 0x06, 0x86, 0x0f	; 2C# 1017350
	.db 0xeb, 0x6f, 0x10	; 2D  1077227
	.db 0xa4, 0x6c, 0x11	; 2D# 1141924
	.db 0x38, 0x72, 0x12	; 2E  1208888
	.db 0x45, 0x8b, 0x13	; 2F  1280837
	.db 0x21, 0xb9, 0x14	; 2F# 1358113
	.db 0x9e, 0xec, 0x15	; 2G  1436830
	.db 0xf1, 0x45, 0x17	; 2G# 1525233
	.db 0xad, 0xa2, 0x18	; 2A  1614509
	.db 0x64, 0x13, 0x1a	; 2A# 1708900
	.db 0xb6, 0x97, 0x1b	; 2B  1808310
	.db 0x00, 0x4c, 0x1d	; 3C  1920000
	.db 0x75, 0x18, 0x1f	; 3C# 2037877
	.db 0x97, 0xd6, 0x20	; 3D  2152087
	.db 0xb4, 0xc9, 0x22	; 3D# 2279860
	.db 0xd2, 0xfb, 0x24	; 3E  2423762
	.db 0x00, 0x10, 0x27	; 3F  2560000
	.db 0x91, 0x63, 0x29	; 3F# 2712465
	.db 0x95, 0xc0, 0x2b	; 3G  2867349
	.db 0xe1, 0x66, 0x2e	; 3G# 3040993
	.db 0xa0, 0x64, 0x31	; 3A  3237024
	.db 0x86, 0x0f, 0x34	; 3A# 3411846
	.db 0xf3, 0x70, 0x37	; 3B  3633395
	.db 0x68, 0x5d, 0x3a	; 4C  3825000
	.db 0x5d, 0x20, 0x3e	; 4C# 4071517
	.db 0x38, 0xd2, 0x41	; 4D  4313656
	.db 0xb0, 0xfb, 0x45	; 4D# 4586416
	.db 0x5d, 0x9a, 0x49	; 4E  4823645
	.db 0xbd, 0x6e, 0x4e	; 4F  5140157
	.db 0x00, 0x02, 0x53	; 4F# 5440000
	.db 0x6b, 0x60, 0x57	; 4G  5726315
	.db 0xc6, 0x17, 0x5d	; 4G# 6100934
	.db 0x86, 0x9f, 0x62	; 4A  6463366
	.db 0x1a, 0xda, 0x68	; 4A# 6871578
	.db 0xc8, 0x44, 0x6e	; 4B  7226568
	.db 0x00, 0x4c, 0x1d	; R   1920000

;
; l𓾂 (read_sound̉)
;
; 
; HL:eLXg̃AhX
;
; o
; A:l
; Cy:lł, NC:lłȂ
; HL:̃eLXg̃AhX
; F:j
;
get_number:
	push BC
	call get_number_main
	pop BC
	ret

get_number_main:
	; 
	ld C, #0

	; ŏ̐l𓾂
	ld A, (HL)
	sub #"0"
	cp #10

	; lłȂȂ߂
	ret NC

get_number_loop:
	; 񓾂lۑ
	ld B, A

	; O񓾂l߂
	ld A, C

	; lłȂȂ߂
	ccf
	ret C

	; O񓾂l10{
	add A
	add A
	add A
	add C
	add C

	; 񓾂lZ
	add B
	ld C, A

	; ̐l𓾂
	inc HL
	ld A, (HL)
	sub #"0"
	cp #10
	jr get_number_loop

;
; E BC = E BC / A, HL = E BC mod A (read_sound̉)
;
; 
; BC:鐔̉16bit
; E:鐔̏8bit
; A:鐔
;
; o
; BC:̉16bit
; E:̏8bit
; HL:]
; AF:j
;
div24_8::
	or A
	ret Z

	push AF
	ld H, #0
	ld L, E
	call div16_8
	ld E, A
	pop AF

	push AF
	ld H, L
	ld L, B
	call div16_8
	ld B, A
	pop AF

	push AF
	ld H, L
	ld L, C
	call div16_8
	ld C, A
	pop AF
	ret

;
; A = HL / A, L = HL mod A (div32_8̉)
;
; 
; HL:鐔
; A:鐔
;
; o
; A:
; L:]
; F:j
;
div16_8:
	push BC

	ld B, #0
	ld C, A
	xor A

div16_8_loop:
	inc A
	sbc HL, BC
	jr NC, div16_8_loop

	dec A
	add HL, BC

	pop BC
	ret

;
; BC = BC / 8 (read_sound̉)
;
; 
; BC:l
;
; o
; BC:͂̐l8Ŋ
; F:j
;
div_bc_8::
	srl B
	rr C
	srl B
	rr C

;
; BC = BC / 2 (read_sound̉)
;
; 
; BC:l
;
; o
; BC:͂̐l2Ŋ
; F:j
;
div_bc_2::
	srl B
	rr C
	ret

;
; 1ǂݍ (read_command̉)
;
; 
; A:G[R[h
; HL:eLXg̓ǍAhX
; IY:̏AhX
;
; o
; HL:eLXg̓ǍAhX
; IY:̏AhX
; F,BC,DE:j
;
read_voice:
	; ݂̏ǂzȂ?
	push HL
	push IY
	pop HL
	push IX
	pop DE
	or A
	sbc HL, DE
	pop HL
	ld A, #1 ; G[ : ƉĂ
	ret NC

	; ݈ʒux?
	ld A, 0(IY)
	or A
	jr Z, read_voice_rest

	; 𓾂
	call get_voice
	jr NC, read_voice_error

	; 
	ld 1(IY), A

	; ?
	cp #255
	jr NZ, read_voice_skip1

	; 1Ỏ̂΂
	push HL
	ld L, -4(IY)
	ld H, -3(IY)
	ld C, -2(IY)
	ld B, -1(IY)
	add HL, BC
	ld -4(IY), L
	ld -3(IY), H
	ld -2(IY), #0
	ld -1(IY), #0
	pop HL
read_voice_skip1:

	; ݈̏ʒuֈڂ
	ld BC, #6
	add IY, BC
	scf
	ret

read_voice_rest:
	; ɂ
	ld 0(IY), #72 ; 3C
	ld 1(IY), #0 ; 

	; ݈̏ʒuֈڂ
	inc IY
	inc IY
	inc IY
	inc IY
	inc IY
	inc IY
	jr read_voice

read_voice_error:
	ld A, #4 ; G[ : sȉR}h
	ret

;
; \特 (read_voicẻ)
;
; 
; HL:eLXg̓ǍAhX
;
; o
; A:
; Cy:v, NC:vȂ
; HL:eLXg̓ǍAhX
; F,BC,DE:j
;
get_voice:
	ld BC, #3
	ld DE, #voice3_table
	call find_item
	ret C

	dec BC
	ld DE, #voice2_table
	call find_item
	ret C

	dec BC
	ld DE, #voice1_table

;
; EoCiϊ\l𓾂 (get_voicẻ)
;
; 
; BC:̒
; DE:\̐擪̃AhX
; HL:̃AhX
;
; o
; A:ϊꂽl
; Cy:v, NC:vȂ
; HL:vƂ̃eLXg̃AhX
; DE:j
;
find_item::
	; v邩?
	push BC
	ld B, C
	call memcmp
	pop BC

	; oCi𓾂
	push AF
	ex DE, HL
	add HL, BC
	ex DE, HL
	pop AF
	ld A, (DE)
	jr C, find_item_last

	; ̕ϊ\̍ڂֈړ
	inc DE

	; \̍Ōォ?
	ld A, (DE)
	or A
	jr NZ, find_item

	; vȂ
	ret

find_item_last:
	; v
	add HL, BC
	scf
	ret

;
; 2̕r (find_item̉)
;
; 
; B:̒
; DE:1
; HL:2
;
; o
; Cy:v, NC:sv
; AF,BC:j
;
memcmp::
	push DE
	push HL

memcmp_loop:
	ld A, (DE)
	inc DE
	cp (HL)
	inc HL
	jr NZ, memcmp_not_match
	djnz memcmp_loop

memcmp_match:
	pop HL
	pop DE
	scf
	ret

memcmp_not_match:
	pop HL
	pop DE
	or A
	ret

;
; (3)
;
voice3_table:
	.ascii /ެ/
	.db 29
	.ascii /ޭ/
	.db 30
	.ascii /ު/
	.db 31
	.ascii /ޮ/
	.db 32
	.ascii /ެ/
	.db 48
	.ascii /ި/
	.db 49
	.ascii /ޭ/
	.db 50
	.ascii /ު/
	.db 51
	.ascii /ޮ/
	.db 52
	.ascii /ެ/
	.db 71
	.ascii /ި/
	.db 72
	.ascii /ޭ/
	.db 73
	.ascii /ު/
	.db 74
	.ascii /ޮ/
	.db 75
	.ascii /ީ/
	.db 76
	.ascii /ެ/
	.db 111
	.ascii /ޭ/
	.db 112
	.ascii /ު/
	.db 113
	.ascii /ޮ/
	.db 114
	.ascii /߬/
	.db 120
	.ascii /߭/
	.db 121
	.ascii /ߪ/
	.db 122
	.ascii /߮/
	.db 123
	.ascii /ާ/
	.db 151
	.ascii /ި/
	.db 152
	.ascii /ު/
	.db 154
	.ascii /ޫ/
	.db 155
	.db 0

;
; (2)
;
voice2_table:
	.ascii //
	.db 16
	.ascii //
	.db 17
	.ascii //
	.db 18
	.ascii //
	.db 19
	.ascii //
	.db 20
	.ascii //
	.db 21
	.ascii //
	.db 22
	.ascii //
	.db 23
	.ascii //
	.db 24
	.ascii //
	.db 25
	.ascii //
	.db 26
	.ascii //
	.db 27
	.ascii //
	.db 28
	.ascii //
	.db 38
	.ascii //
	.db 39
	.ascii //
	.db 40
	.ascii //
	.db 41
	.ascii //
	.db 42
	.ascii //
	.db 43
	.ascii //
	.db 44
	.ascii //
	.db 45
	.ascii //
	.db 46
	.ascii //
	.db 47
	.ascii /ì/
	.db 58
	.ascii /è/
	.db 59
	.ascii /í/
	.db 60
	.ascii /ê/
	.db 61
	.ascii /î/
	.db 62
	.ascii /ĩ/
	.db 63
	.ascii /§/
	.db 64
	.ascii /¨/
	.db 65
	.ascii /ª/
	.db 66
	.ascii /«/
	.db 67
	.ascii //
	.db 68
	.ascii //
	.db 44
	.ascii //
	.db 45
	.ascii //
	.db 69
	.ascii //
	.db 70
	.ascii //
	.db 77
	.ascii //
	.db 78
	.ascii //
	.db 79
	.ascii //
	.db 80
	.ascii /Ƭ/
	.db 86
	.ascii /ƭ/
	.db 87
	.ascii /ƪ/
	.db 88
	.ascii /Ʈ/
	.db 89
	.ascii /ˬ/
	.db 95
	.ascii /˭/
	.db 96
	.ascii /˪/
	.db 97
	.ascii /ˮ/
	.db 98
	.ascii /̧/
	.db 99
	.ascii /̨/
	.db 100
	.ascii /̪/
	.db 101
	.ascii /̫/
	.db 102
	.ascii /̬/
	.db 103
	.ascii /̭/
	.db 104
	.ascii /̮/
	.db 105
	.ascii //
	.db 106
	.ascii //
	.db 107
	.ascii //
	.db 108
	.ascii //
	.db 109
	.ascii //
	.db 110
	.ascii //
	.db 115
	.ascii //
	.db 116
	.ascii //
	.db 117
	.ascii //
	.db 118
	.ascii //
	.db 119
	.ascii /Ь/
	.db 129
	.ascii /Э/
	.db 130
	.ascii /Ъ/
	.db 131
	.ascii /Ю/
	.db 132
	.ascii //
	.db 135
	.ascii /ج/
	.db 142
	.ascii /ح/
	.db 143
	.ascii /ت/
	.db 144
	.ascii /خ/
	.db 145
	.ascii //
	.db 147
	.ascii //
	.db 148
	.ascii //
	.db 149
	.ascii //
	.db 150
	.ascii //
	.db 153
	.db 0

;
; (1)
;
voice1_table:
	.ascii //
	.db 6
	.ascii //
	.db 7
	.ascii //
	.db 8
	.ascii //
	.db 9
	.ascii //
	.db 10
	.ascii //
	.db 10
	.ascii //
	.db 11
	.ascii //
	.db 12
	.ascii //
	.db 13
	.ascii //
	.db 14
	.ascii //
	.db 15
	.ascii //
	.db 33
	.ascii //
	.db 34
	.ascii //
	.db 35
	.ascii //
	.db 36
	.ascii //
	.db 37
	.ascii //
	.db 53
	.ascii //
	.db 54
	.ascii //
	.db 55
	.ascii //
	.db 56
	.ascii //
	.db 57
	.ascii //
	.db 81
	.ascii //
	.db 82
	.ascii //
	.db 83
	.ascii //
	.db 84
	.ascii //
	.db 85
	.ascii //
	.db 90
	.ascii //
	.db 91
	.ascii //
	.db 92
	.ascii //
	.db 93
	.ascii //
	.db 94
	.ascii //
	.db 124
	.ascii //
	.db 125
	.ascii //
	.db 126
	.ascii //
	.db 127
	.ascii //
	.db 128
	.ascii //
	.db 133
	.ascii //
	.db 134
	.ascii //
	.db 136
	.ascii //
	.db 137
	.ascii //
	.db 138
	.ascii //
	.db 139
	.ascii //
	.db 140
	.ascii //
	.db 141
	.ascii //
	.db 146
	.ascii //
	.db 156
	.ascii //
	.db 0
	.ascii //
	.db 255
	.db 0

;
; Copyright 2013 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
