;
; POCKET SINGER for SHARP POCKET COMPUTER PC-G850/S/V/VS
; C
;

;	ld BC, #72
;	ld DE, #2
;	ld IX, #voice_a
;	jp speak

start::
	jr main
start2::
	jr skip_compile

main:
	; ̂ϊ
	call compile_song
	jr C, ok

err:
	; uG[v\
	push AF
	push DE
	push HL
	ld DE, #0x0000
	ld HL, #string_ng
	call print

	; sԍ\
	pop HL
	call print_num16
	ld A, #":"
	call print_chr

	; \
	pop HL
	call print_num8

	; G[e\
	pop AF
	add A
	ld C, A
	ld B, #0
	ld HL, #error_table
	add HL, BC
	ld A, (HL)
	inc HL
	ld H, (HL)
	ld L, A
	ld DE, #0x0100
	call print
	call 0xbcc4
	cp #5 ; BREAKL[
	ret Z

ok:
	; ̂
skip_compile:
	ld HL, #song
	jp sing

;
; ʂ
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
;cls::
;	ld A, #" "
;	ld B, #24 * 6
;	ld DE, #0x0000
;	jp 0xbfee

;
; \
;
; 
; DE:ʒu
; HL:̐擪AhX
;
; o
; DE:Ōɕ\̈ʒu
; HL:̃̕AhX
; AF,BC:j
;
print::
	ld A, (HL)
	inc HL
	or A
	ret Z

	call print_chr
	jr print

;
; l\(16bit)
;
; 
; DE:ʒu
; HL:l
;
; o
; AF,BC,HL:j
; DE:̈ʒu
;
print_num16::
	ld BC, #-10000
	call print_num16_1
	ld BC, #-1000
	call print_num16_1

;
; l\(8bit)
;
; 
; HL:l
; DE:ʒu
;
; o
; AF,BC,HL:j
; DE:̈ʒu
;
print_num8::
	ld BC, #-100
	call print_num16_1
	ld BC, #-10
	call print_num16_1
	ld BC, #-1

print_num16_1:
	; w肵̒l𓾂
	ld A, #"0" - 1
print_num16_1_loop:
	inc A
	add HL, BC
	jr C, print_num16_1_loop
	sbc HL, BC

;
; 1\
;
; 
; A:
; DE:ʒu
;
; o
; DE:̈ʒu
; AF,BC:j
;
print_chr::
	push HL
	call 0xbe5f
	pop HL
	inc E
	ret

; G[\
error_table:
	.dw string_error0
	.dw string_error1
	.dw string_error2
	.dw string_error3
	.dw string_error4
	.dw string_error5
	.dw string_error6
	.dw string_error7
	.dw string_error8

; 
string_ng:
	.ascii /װ \0/
string_error0:
	.ascii /ض Ų\0/
string_error1:
	.ascii /ò ݾ ò\0/
string_error2:
	.ascii /ݾ Ų\0/
string_error3:
	.ascii /Ҳ ò\0/
string_error4:
	.ascii /Ҳ ݾ\0/
string_error5:
	.ascii /Ķ ˸\0/
string_error6:
	.ascii /Ķ \0/
string_error7:
	.ascii /Ķ Ŷ޽\0/
string_error8:
	.ascii /Ұ ݲ޲\0/

;
; Copyright 2013 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
